//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Lime
#property indicator_color2  Red
#property indicator_color3  Aqua
#property indicator_color4  Violet

input double ATR=2;

double bartu[];
double bartd[];
double trend[];
double vel[];
double vel1[];
double vel3[];
double temp;

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,bartu); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,bartd); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,vel);
      SetIndexStyle(2,DRAW_LINE);
      SetIndexBuffer(3,vel3);
      SetIndexStyle(3,DRAW_ARROW);
      SetIndexArrow(3,159);
      SetIndexBuffer(4,trend);
   return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
   int j;
   ArrayResize( vel1,Bars );
   ArraySetAsSeries( vel1, True );
   
   for(int i=limit; i>=0; i--)
   {
   vel1[i] = iClose(NULL,0,i) - ATR*iATR( NULL, 0, 10, i);
   temp = 0;
            for ( j = 0; j < 15; j++ ) {
            temp = MathMax(temp,vel1[i+j]);
            }
            vel[i] = temp;
   }
   
   for(i=limit; i>=0; i--)
   {
           
         bartu[i] = EMPTY_VALUE;
         bartd[i] = EMPTY_VALUE;
         
            if (iClose(NULL,0,i )> iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW,20,i)) + ATR*iATR( NULL, 0, 10, i)) {
            trend[i] =  1;
            vel3[i] = iMA(NULL,0,13,0,MODE_EMA,PRICE_HIGH,i) + ATR*iATR( NULL, 0, 10, i);
            }
            
            if (iClose(NULL,0,i) < iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH,20,i)) - ATR*iATR( NULL, 0, 10, i)) {
            trend[i] = -1;
             vel3[i] = iMA(NULL,0,13,0,MODE_EMA,PRICE_LOW,i) - ATR*iATR( NULL, 0, 10, i);
            }
               if (trend[i]== 1) { bartu[i] = High[i]; bartd[i] = Low[i]; }
               if (trend[i]==-1) { bartd[i] = High[i]; bartu[i] = Low[i]; }
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
